﻿using CommonDll;
using IAddins;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.Composition;
using System.ComponentModel.Composition.Hosting;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace MEFDemo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            LoadAddins();
            label1.Text = "v4.0";
        }

        [ImportMany(AllowRecomposition = true)]
        public IEnumerable<Lazy<IAddin, IModuleAttribute>> Plugs;

        void LoadAddins()
        {
            try
            {
                AggregateCatalog catalog = new AggregateCatalog();

                catalog.Catalogs.Add(new DirectoryCatalog($"Addins\\Addin1", "Addin_1.dll"));
                catalog.Catalogs.Add(new DirectoryCatalog($"Addins\\Addin2", "Addin_2.dll"));
                catalog.Catalogs.Add(new DirectoryCatalog($"Addins\\Addin3", "Addin_3.dll"));
                catalog.Catalogs.Add(new DirectoryCatalog($"Addins\\Addin4", "Addin_4.dll"));
                catalog.Catalogs.Add(new DirectoryCatalog($"Addins\\Addin5", "Addin_5.dll"));

                CompositionContainer container = new CompositionContainer(catalog);
                container.ComposeParts(this);

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        void ExecAddinFunc(string addinModuleName)
        {
            foreach (var plug in Plugs)
            {
                if (plug.Metadata.ModuleName == addinModuleName)
                {
                    try
                    {
                        plug.Value.Run();
                    }
                    catch (Exception ex)
                    {
                        MessageBox.Show($"{addinModuleName} 执行方法时出错！\r\n" + ex.Message);
                    }
                }
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            var common = new Common();
            string s = common.Test("主程序，引用CommonDll版本：v3.0，调用方法：Test(string str , int i)。",0);
            MessageBox.Show(s);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            ExecAddinFunc("Addin1");
        }

        private void button3_Click(object sender, EventArgs e)
        {
            ExecAddinFunc("Addin2");
        }

        private void button4_Click(object sender, EventArgs e)
        {
            ExecAddinFunc("Addin3");
        }

        private void button5_Click(object sender, EventArgs e)
        {
            ExecAddinFunc("Addin4");
        }

        private void button6_Click(object sender, EventArgs e)
        {
            ExecAddinFunc("Addin5");
        }
    }
}
